/*
 * Copyright (C) 2008, 2009 Ingo Luetkebohle <iluetkeb@techfak.uni-bielefeld.de>
 * Made available under the terms of the GNU General Public License v3
 */

package de.unibi.agai.xml;

import nu.xom.Attribute;
import nu.xom.Document;
import nu.xom.Element;
import nu.xom.ParentNode;

/**
 *
 * @author ingo
 */
public class AttributeSplice extends TextSplice {
    private final String attrName;

    public AttributeSplice(String attrName) {
        this.attrName = attrName;
    }

    @Override
    public ParentNode assignTo(ParentNode n, String o) {
        if(n instanceof Document) {
            n = ((Document)n).getRootElement();
        }
        Element e = (Element)n;
        Attribute a = new Attribute(attrName, o);
        e.addAttribute(a);

        return n;
    }
}
