/*
 * Copyright (C) 2008, 2009 Ingo Luetkebohle <iluetkeb@techfak.uni-bielefeld.de>
 * Made available under the terms of the GNU General Public License v3
 */

package de.unibi.agai.xml;

import de.unibi.agai.xml.transport.TransportConversionException;
import nu.xom.Element;

/**
 *
 * @author ingo
 */
public abstract class ElementConverter<T> implements TypeConverter<T, Element> {
    private final String elementName;
    private final String nsURI;
    
    public ElementConverter(String elementName, String nsURI) {
        this.elementName = elementName;
        this.nsURI = nsURI;
    }

    public T fromTransport(Element data, ValuePolicy<T> vp) throws TransportConversionException {
        return vp.check(extract(data));
    }

    public Element toTransport(T data) {
        Element e = new Element(elementName, nsURI);
        fill(e, data);
        return e;
    }

    protected abstract void fill(Element e, T data);
    protected abstract T extract(Element e);
}
