/*
 * Copyright (C) 2008, 2009 Ingo Luetkebohle <iluetkeb@techfak.uni-bielefeld.de>
 * Made available under the terms of the GNU General Public License v3
 */

package de.unibi.agai.xml;

/**
 *
 * @author iluetkeb
 */
public class EnumConverter<T extends Enum> extends StringConverter<T> {
    private final Class<T> clazz;
    
    public EnumConverter(Class<T> clazz) {
        this.clazz = clazz;
    }

    @Override
    protected T parse(String data) {
        return (T) Enum.valueOf(clazz, data);
    }

}
