/*
 * Copyright (C) 2008, 2009 Ingo Luetkebohle <iluetkeb@techfak.uni-bielefeld.de>
 * Made available under the terms of the GNU General Public License v3
 */

package de.unibi.agai.xml;

import de.unibi.agai.xml.transport.TransportConversionException;

/**
 * Check the the value is neither null nor empty.
 * 
 * @author ingo
 */
public class NonEmptyString implements ValuePolicy<String> {
    /**
     * Check that the String is neither null nor empty (after trimming).
     * @return a trimmed version of the String 
     */
    public String check(String value) throws TransportConversionException {
        if(value == null || (value = value.trim()).length() == 0)
            throw new TransportConversionException("String value empty.");
        return value;
    }
}
