/*
 * Copyright (C) 2008, 2009 Ingo Luetkebohle <iluetkeb@techfak.uni-bielefeld.de>
 * Made available under the terms of the GNU General Public License v3
 */

package de.unibi.agai.xml;

import de.unibi.agai.xml.transport.TransportConversionException;

/**
 *
 * @author ingo
 */
public abstract class StringConverter<T> implements TypeConverter<T, String> {
    public final T fromTransport(String data, ValuePolicy<T> vp) throws TransportConversionException {
        if(vp == null)
            return parse(data);
        else
            return vp.check(parse(data));
    }
    public final String toTransport(T data) {
        return data.toString();
    }
    protected abstract T parse(String data);
}
