/*
 * Copyright (C) 2008, 2009 Ingo Luetkebohle <iluetkeb@techfak.uni-bielefeld.de>
 * Made available under the terms of the GNU General Public License v3
 */

package de.unibi.agai.xml;

import de.unibi.agai.xml.transport.TransportConversionException;

/**
 * Interface for data-conversion that can convert data to and from
 * a transport format.
 *
 * @author ingo
 */
public interface TypeConverter<T,O> {
    /**
     * Converts from the format for transport, checking against the given
     * ValuePolicy.
     */
    T fromTransport(O data, ValuePolicy<T> vp) throws TransportConversionException;
    /** 
     * Converts to transport.
     */
    O toTransport(T data);
}
