/*
 * Copyright (C) 2008, 2009 Ingo Luetkebohle <iluetkeb@techfak.uni-bielefeld.de>
 * Made available under the terms of the GNU General Public License v3
 */

package de.unibi.agai.xml;

import de.unibi.agai.xml.transport.TransportConversionException;

/**
 * A pluggable interface that can be used to handle all sorts of
 * checks against a source value transparently to the conversion code.
 *
 * @author ingo
 */
public interface ValuePolicy<T> {
    /**
     * Checks whether the value satisfies the constraints of this policy.
     * @throws TransportConversionException if some constraint is not satisfied.
     * @return the input value, possibly normalized in some way
     */
    T check(T value) throws TransportConversionException;
}
