/*
 * Copyright 2008, 2009 Bielefeld University
 * Copyright 2008, 2009 Ingo Luetkebohle <ingo@fargonauten.de>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, version 3.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

package de.unibi.agai.xml.transport;

import nu.xom.Node;
import nu.xom.ParentNode;

/**
 *
 * @author iluetkeb
 */
public class ClassTransportAdapter extends AbstractTransportAdapter<Class> {
    private StringChildTransportAdapter ta = new StringChildTransportAdapter();

    public ClassTransportAdapter() {
        super(Class.class, "Class");
    }

    @Override
    public ParentNode adapt(ParentNode context, Class o) {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    @Override
    public Class unpack(Node data) throws TransportConversionException {
        final String className = ta.unpack(data);
        try {
            return Class.forName(className);
        } catch (ClassNotFoundException ex) {
            throw new TransportConversionException("Could not load class " +
                    className, ex);
        }
    }
}
