/*
 * Copyright 2008, 2009 Bielefeld University
 * Copyright 2008, 2009 Ingo Luetkebohle <ingo@fargonauten.de>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, version 3.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

package de.unibi.agai.xml.transport;

import de.unibi.agai.xml.ElementAttrSplice;
import de.unibi.agai.xml.StringConverter;
import java.util.Date;
import nu.xom.Attribute;
import nu.xom.Document;
import nu.xom.Element;
import org.jaxen.JaxenException;
import org.jaxen.xom.XOMXPath;

/**
 *
 * @author iluetkeb
 */
public class DateTransportAdapter extends TemplateTransportAdapter<Date, String> {
    private static final Document template;
    private static XOMXPath xpath = null;
    static {
        Element root = new Element("TIMESTAMP");
        Element inserted = new Element("INSERTED");
        inserted.addAttribute(new Attribute("value", ""));
        root.appendChild(inserted);
        template = new Document(root);
        try {
            xpath = new XOMXPath("/*/TIMESTAMP/INSERTED");
        } catch (JaxenException ex) {            
        }
    }

    public DateTransportAdapter() throws JaxenException {
        super(template, xpath,
                new ElementAttrSplice("INSERTED", "value"), new DateConverter(),
                null, null, Date.class);
    }
}
final class DateConverter extends StringConverter<Date> {
    @Override
    protected Date parse(String data) {
        if(data == null)
            return new Date();
        return new Date(Long.parseLong(data));
    }
}