/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package de.unibi.agai.xml.transport;

import nu.xom.Element;
import nu.xom.Node;
import nu.xom.ParentNode;

/**
 *
 * @author iluetkeb
 */
public class ExternalTransportAdapter extends AbstractTransportAdapter {
    private final TransportContext context;

    public ExternalTransportAdapter() {
        this(null);
    }

    ExternalTransportAdapter(TransportContext context) {
        super(Object.class, "external");
        this.context = context;
    }

    @Override
    public ParentNode adapt(ParentNode context, Object o) {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    @Override
    public Object unpack(Node data) throws TransportConversionException {
        if(context == null)
            throw new TransportConversionException("Needs TransportContext for lookup");
        final String name = ((Element)data).getAttributeValue("name");
        if(name == null)
            throw new TransportConversionException("Name attribute missing");
        final Object result = context.get(name);
        if(result == null)
            throw new TransportConversionException("No binding for " + name);

        return result;
    }

    @Override
    public TransportAdapter setContext(TransportContext context) {
        return new ExternalTransportAdapter(context);
    }
}
