/*
 * Copyright 2008, 2009 Bielefeld University
 * Copyright 2008, 2009 Ingo Luetkebohle <ingo@fargonauten.de>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, version 3.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

package de.unibi.agai.xml.transport;

import java.util.HashMap;
import java.util.Map;

/**
 * Map-based default TransportContext implementation.
 *
 * @author iluetkeb
 */
public class SimpleTransportContext implements TransportContext {
    private final Map<String, Object> variableMap = new HashMap();

    public Object get(String name) {
        return variableMap.get(name);
    }

    /**
     * Sets variable "name" to new value. The old value is returned. If no old
     * value was present, null is returned.
     */
    public Object put(String name, Object value) {
        return variableMap.put(name, value);
    }

}
