/*
 * Copyright 2008, 2009 Bielefeld University
 * Copyright 2008, 2009 Ingo Luetkebohle <ingo@fargonauten.de>
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, version 3.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

package net.sf.xcf.fts;

/**
 * Event generated when a Node returns a null inputEvent or null data and that
 * provides information the problematic node and the corresponding input.
 *
 * @author iluetkeb
 */
public class NullEvent {
    /** The node that returned null. */
    public final Node<?,?> source;
    /** The input that was given to handleEvent. */
    public final Event<?> inputEvent;

    public NullEvent(Node<?,?> source, Event<?> inputEvent) {
        this.source = source;
        this.inputEvent = inputEvent;
    }

    @Override
    public String toString() {
        return "NullEvent[source node=" + source + ", input=" + inputEvent + "]";
    }
}
