/*
 * Copyright 2008, 2009 Bielefeld University
 * Copyright 2008, 2009 Ingo Luetkebohle <ingo@fargonauten.de>
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, version 3.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package net.sf.xcf.fts;

import java.util.UUID;

/**
 * Event factory that applies a source tag.
 * 
 * @author iluetkeb
 */
public class TaggingEventFactory implements EventFactory {

    /** The events UUID. */
    public static final String TAG_KEY = "event.uuid";
    /** The events creation timestamp. */
    public static final String TIMESTAMP_TAG_KEY = "event.creationtime";

    public <T> Event<T> createNewEvent(T o) {
        return new DefaultEvent<T>(o).addTags(new Pair<String, Object>(TAG_KEY,
                UUID.randomUUID()), new Pair<String, Object>(TIMESTAMP_TAG_KEY, System.currentTimeMillis()));

    }
}
