/*
 * Copyright 2008, 2009 Bielefeld University
 * Copyright 2008, 2009 Ingo Luetkebohle, Sebastian Wrede, Jan Schaefer
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, version 3.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package net.sf.xcf.fts;

/**
 *
 * @author iluetkeb
 */
public class Triple<T1, T2, T3> {
    public final T1 first;
    public final T2 second;
    public final T3 third;

    public Triple(T1 a, T2 b, T3 c) {
        this.first = a;
        this.second = b;
        this.third = c;
    }

    @Override
    public boolean equals(Object o) {
        if(o == this)
            return true;
        if(!(o instanceof Triple))
            return false;
        return first.equals(((Triple)o).first) &&
                second.equals(((Triple)o).second) &&
                third.equals(((Triple)o).third);
    }

    @Override
    public int hashCode() {
        int hash = 7;
        hash = 67 * hash + (this.first != null ? this.first.hashCode() : 0);
        hash = 67 * hash + (this.second != null ? this.second.hashCode() : 0);
        hash = 67 * hash + (this.third != null ? this.third.hashCode() : 0);
        return hash;
    }

    @Override
    public String toString() {
        return "Triple[a=" + first + ", b=" + second + ", c=" + third + "]";
    }
}
