/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package net.sf.xcf.fts.engine;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.Iterator;
import java.util.List;
import net.sf.xcf.fts.Event;
import net.sf.xcf.fts.Node;
import net.sf.xcf.fts.Pair;
import net.sf.xcf.fts.nodes.filter.Filter;

/**
 *
 * @author ingo
 */
class AllOfSelector<T> implements Node<T,Iterator<DestinationPair<T>>> {
    private final Pair<? extends Filter<T>, Node<? super T,?>> [] cases;

    public AllOfSelector(Pair<? extends Filter<T>, Node<? super T,?>> ... cases) {
        this.cases = Arrays.copyOf(cases, cases.length);
    }

    public Event<? extends Iterator<DestinationPair<T>>> handleEvent(Event<? extends T> input) throws Exception {
        List<DestinationPair<T>> destinations = new ArrayList<DestinationPair<T>>();
        for(Pair<? extends Filter<T>, ? extends Node<? super T,?>> c : cases) {
            if(c.first.handleEvent(input) != null) {
                DestinationPair<T> dp = new DestinationPair<T>((Node<? super T, ?>) c.second, input.getData());
                destinations.add(dp);
            }
        }
        return input.createDerived(destinations.iterator());
    }

}
