/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package net.sf.xcf.fts.engine;

import java.util.Arrays;
import net.sf.xcf.fts.Event;
import net.sf.xcf.fts.Node;
import net.sf.xcf.fts.Pair;
import net.sf.xcf.fts.nodes.filter.Filter;

/**
 *
 * @author ingo
 */
class FirstOfSelector<T> implements Node<T,DestinationPair<T>>{
    private final Pair<? extends Filter<T>, Node<? super T,?>> [] cases;

    public FirstOfSelector(Pair<? extends Filter<T>, Node<? super T,?>> ... cases) {
        this.cases = Arrays.copyOf(cases, cases.length);
    }

    public Event<? extends DestinationPair<T>> handleEvent(Event<? extends T> input) throws Exception {
        for(Pair<? extends Filter<T>, ? extends Node<? super T,?>> c : cases) {
            if(c.first.handleEvent(input) != null)
                return input.createDerived(new DestinationPair<T>(c.second, input.getData()));
        }
        return null;
    }

}
