/*
 * Copyright 2008, 2009 Bielefeld University
 * Copyright 2008, 2009 Ingo Luetkebohle, Sebastian Wrede, Jan Schaefer
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, version 3.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

package net.sf.xcf.fts.engine;

import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author iluetkeb
 */
public class LoggingErrorHandler implements NodeErrorHandler {
    private final Logger logger;

    public LoggingErrorHandler(Logger logger) {
        this.logger = logger;
    }

    public void eventHandlingFailed(NodeErrorEvent evt) throws TerminateEngineException {
        Exception t = evt.getError();
        logger.logp(Level.WARNING, evt.getWorkNode().getClass().getName(),
                "handleEvent",
                "on input from " + evt.getSourceNode(),
                t);
    }

}
