/*
 * Copyright 2008, 2009 Bielefeld University
 * Copyright 2008, 2009 Ingo Luetkebohle <ingo@fargonauten.de>
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, version 3.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

package net.sf.xcf.fts.engine;

import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author iluetkeb
 */
public class LoggingNodeErrorHandler implements NodeErrorHandler {
    private static final Logger logger = Logger.getLogger("FTS.NodeErrorHandler");

    @Override
    public void eventHandlingFailed(NodeErrorEvent evt) throws TerminateEngineException {
        Class<?> sourceClass = evt.getSourceNode() != null ?
            evt.getSourceNode().getClass() :
            evt.getWorkNode().getClass();
        logger.logp(Level.WARNING, sourceClass.getName(),
                "handleEvent", evt.toString(), evt.getError());
    }

}
