/*
 * Copyright 2008, 2009 Bielefeld University
 * Copyright 2008, 2009 Ingo Luetkebohle, Sebastian Wrede, Jan Schaefer
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, version 3.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

package net.sf.xcf.fts.engine;

/**
 *
 * @author iluetkeb
 */
public interface NodeErrorHandler {
    /**
     * Handle notification of an error that occured during engine exceution.
     *
     * If the error handler decides that the error is fatal and wants to
     * abort execution, it may throw a TerminateEngineException.
     */
    void eventHandlingFailed(NodeErrorEvent evt) throws TerminateEngineException;
}
