/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package net.sf.xcf.fts.marks;

import net.sf.xcf.fts.Node;

/**
 * Marker for an emitter that specifies the emitted type.
 *
 * @author iluetkeb
 */
public class EmitTypeMark<T> extends SourceConnectorMark<T>
        implements SourceConnectableMark {
    private final Class<? super T> outtype;

    public EmitTypeMark(Node<?, ? extends T> node, Class<? super T> outtype) {
        super(node);
        this.outtype = outtype;
    }
    public EmitTypeMark(Node<?, ? extends T> node, String scope, Class<? super T> outtype) {
        super(node, scope);
        this.outtype = outtype;
    }

    public boolean isCompatible(Marked m) {
        return (m instanceof ReceiveTypeMark<?> &&
                ((ReceiveTypeMark<?>)m).canReceive(outtype));
    }

    @Override
    public String toString() {
        return "EmitMark[outtype=" + outtype.getName() + ", node=" + node + "]";
    }
}
