/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package net.sf.xcf.fts.marks;

import net.sf.xcf.fts.Node;

/**
 *
 * @author iluetkeb
 */
public class Mark implements Marked {
    protected final Node<?, ?> node;
    protected final String scope;

    public Mark(Node<?, ?> node) {
        this(node, SCOPE_DEFAULT);
    }
    public Mark(Node<?, ?> node, String scope) {
        if(node == null)
            throw new NullPointerException("Node is null");
        if(scope == null)
            throw new NullPointerException("Scope is null");
        this.node = node;
        this.scope = scope;
    }

    public final Node<?, ?> getNode() {
        return node;
    }

    public final Object getScope() {
        return scope;
    }

    @Override
    public boolean isInScope(String scope) {
        return scope != null && this.scope.equals(scope);
    }

    public static String createScope(String label) {
        return "scope." + label;
    }
}
