/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package net.sf.xcf.fts.marks;

import net.sf.xcf.fts.Node;

/**
 * Marker for a receiver node that specifies acceptable input type.
 * 
 * @author iluetkeb
 */
public class ReceiveTypeMark<T> extends Mark {
    private final Class<? extends T> intype;

    public ReceiveTypeMark(Node<? super T, ?> node, Class<? extends T> intype) {
        super(node);
        this.intype = intype;
    }

    public ReceiveTypeMark(Node<? super T, ?> node, String scope, Class<? extends T> intype) {
        super(node, scope);
        this.intype = intype;
    }

    public boolean canReceive(Class<?> type) {
        return intype.isAssignableFrom(type);
    }

    @Override
    public String toString() {
        return "ReceiveMark[intype=" + intype.getName() + ", node=" + node + "]";
    }
}
