/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package net.sf.xcf.fts.marks;

import net.sf.xcf.fts.Node;
import net.sf.xcf.fts.engine.Graph;

/**
 *
 * @author iluetkeb
 */
public abstract class SourceConnectorMark<TOut> extends Mark implements
        SourceConnectableMark {
    
    public SourceConnectorMark(Node<?, ? extends TOut> node, String scope) {
        super(node, scope);
    }
    public SourceConnectorMark(Node<?, ? extends TOut> node) {
        super(node);
    }

    public boolean connectIfCompatible(Graph g, Marked m) {
        if(!m.isInScope(scope))
            return false;
        if(isCompatible(m)) {
            g.connect((Node<?,? extends TOut>)node,
                        (Node<? super TOut,?>)m.getNode());
            return true;
        }
        return false;
    }

    protected abstract boolean isCompatible(Marked m);
}
