/*
 * Copyright 2008, 2009 Bielefeld University
 * Copyright 2008, 2009 Ingo Luetkebohle, Sebastian Wrede, Jan Schaefer
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, version 3.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

package net.sf.xcf.fts.nodes;

import java.util.Arrays;
import java.util.HashSet;
import java.util.Map;
import java.util.Set;

import net.sf.xcf.fts.Event;

/**
 * A filter that checks whether the argument-map has a number of required keys.
 *
 * @author iluetkeb
 */
public class CheckCompleteDataFilter extends AbstractNode<Map, Map> {
    private Set<String> requiredElements;

    
    public CheckCompleteDataFilter(String ... names) {
        super("cfilt");
        requiredElements = new HashSet<String>(names.length);
        requiredElements.addAll(Arrays.asList(names));
    }

    @Override
	public Event<? extends Map> handleEvent(Event<? extends Map> input) {
        if(!input.getData().keySet().containsAll(requiredElements)){
        	System.out.println("CheckCompleteDataStructure " + input);
        	return input;
        }
        else
            return null;
    }



}
