/*
 * Copyright 2008, 2009 Bielefeld University
 * Copyright 2008, 2009 Ingo Luetkebohle, Sebastian Wrede, Jan Schaefer
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, version 3.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

package net.sf.xcf.fts.nodes;

import net.sf.xcf.fts.Event;
import net.sf.xcf.fts.Node;

/**
 * When called, this node throws an exception of pre-specified type.
 * It is intended to be used together with SelectFirstNode, to throw an
 * exception when no match is found.
 *
 * @author iluetkeb
 */
public abstract class ExceptionNode<TIn,TOut> implements Node<TIn,TOut> {

    public Event<TOut> handleEvent(Event<? extends TIn> input) throws Exception {
        throw createException(input);
    }

    protected abstract Exception createException(Object input);

}
