/*
 * Copyright 2008, 2009 Bielefeld University
 * Copyright 2008, 2009 Ingo Luetkebohle, Sebastian Wrede, Jan Schaefer
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, version 3.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package net.sf.xcf.fts.nodes;

import net.sf.xcf.fts.Event;
import net.sf.xcf.fts.annotations.NodeName;
import net.sf.xcf.fts.nodes.filter.AbstractFilter;

/**
 *
 * @author iluetkeb
 */
@NodeName("Print")
public class PrintNode<T> extends AbstractFilter<T> {
    private final String prefix;
    
    /** Creates print node with prefix "PrintNode ". */
    public PrintNode() {        
        this("PrintNode ");
    }
    /**
     * Creates print node that prefixes all output with given string.
     * @param prefix prefix for print output
     */
    public PrintNode(String prefix) {        
        this.prefix = prefix;
    }

    @Override
    public boolean isMatch(Event<? extends T> e) throws Exception {
        System.out.println(prefix + e.toString());
        return true;
    }

    @Override
    public String toString() {
        return "print";
    }
}
