/*
 * Copyright 2008, 2009 Bielefeld University
 * Copyright 2008, 2009 Ingo Luetkebohle <ingo@fargonauten.de>
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, version 3.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

package net.sf.xcf.fts.nodes;

import net.sf.xcf.fts.Event;
import net.sf.xcf.fts.Node;

/**
 * Simply do-nothing node that is just there so that it can be marked.
 * 
 * @author iluetkeb
 */
public class Slot<T> implements Node<T,T> {
    private final String name;
    
    public Slot(String name) {
        this.name = name;
    }
    
    public Slot() {
        this.name = "Slot";
    }

    public Event<? extends T> handleEvent(Event<? extends T> input) throws Exception {
        return input;
    }

    @Override
    public String toString() {
        return name;
    }

}
