/*
 * Copyright 2008, 2009 Bielefeld University
 * Copyright 2008, 2009 Ingo Luetkebohle, Sebastian Wrede, Jan Schaefer
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, version 3.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

package net.sf.xcf.fts.nodes;

import net.sf.xcf.fts.Event;
import net.sf.xcf.fts.annotations.NodeName;
import nu.xom.Serializer;
import nu.xom.Document;


/**
 * Format a Document and print it to standard out.
 *
 * @author iluetkeb, jschaefe
 */
@NodeName("XMLPrint")
public class XOMPrintNode extends AbstractNode<Document,Document> {
    private final Serializer serializer = new Serializer(System.out);

    public XOMPrintNode() {
        super("print");
        serializer.setIndent(4);

    }

    @Override
    public Event<? extends Document> handleEvent(Event<? extends Document> input) throws Exception {
        serializer.write((Document)input.getData());
        return input;
    }

    
}
