/*
 * Copyright 2008, 2009 Bielefeld University
 * Copyright 2008, 2009 Ingo Luetkebohle <ingo@fargonauten.de>
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, version 3.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

package net.sf.xcf.fts.nodes.correlation;

import net.sf.xcf.fts.Event;
import net.sf.xcf.fts.annotations.NodeName;
import net.sf.xcf.fts.Node;

/**
 * Transformer that produces a Future correlated with the given input object.
 *
 * @author iluetkeb
 */
@NodeName("CreateCorrelator")
public class FutureCorrelatableNode<T> implements Node<T, CorrelatableFuture>{
    private final String tagName;

    public FutureCorrelatableNode(String tagName) {
        this.tagName = tagName;
    }

    public Event<? extends CorrelatableFuture> handleEvent(Event<? extends T> input) throws Exception {
        return input.createDerived(new CorrelatableFuture(new TagCorrelator(tagName, input.getTag(tagName))));
    }


}
