/*
 * Copyright 2008, 2009 Bielefeld University
 * Copyright 2008, 2009 Ingo Luetkebohle <ingo@fargonauten.de>
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, version 3.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

package net.sf.xcf.fts.nodes.correlation;

import java.util.concurrent.TimeUnit;
import net.sf.xcf.fts.Event;
import net.sf.xcf.fts.Node;

/**
 * Interface that matches a tagged input event to a result event.
 * 
 * @author iluetkeb
 */
public interface OutputCorrelator<T> extends Node<T,Void> {
    /**
     * Wait for an event that constitutes a "result" to the given input event.
     * In event-lingo, this is simply any event that is derived from the input
     * event. Derivation is determined by the TaggingEventFactory.TAG_KEY
     * tag.
     */
    T waitForResult(Event<?> in) throws InterruptedException;

    T waitForResult(Event<?> in, long timeout, TimeUnit unit) throws InterruptedException;
}
