/*
 * Copyright 2008, 2009 Bielefeld University
 * Copyright 2008, 2009 Ingo Luetkebohle, Sebastian Wrede, Jan Schaefer
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, version 3.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

package net.sf.xcf.fts.nodes.filter;

import net.sf.xcf.fts.Event;
import net.sf.xcf.fts.Node;

/**
 * A base filter class that returns the received unchanged when an
 * indicator function returns true.
 *
 * Note: The indicator function gets a reference to the object, so if the
 * object is not immutable, it could be modified by subclasses.
 *
 * @author iluetkeb
 */
public abstract class AbstractFilter<T> implements Filter<T> {

    @Override
    public Event<? extends T> handleEvent(Event<? extends T> input) throws Exception {
        if(isMatch(input))
            return input;
        else
            return null;
    }

}
