/*
 * Copyright 2008, 2009 Bielefeld University
 * Copyright 2008, 2009 Ingo Luetkebohle <ingo@fargonauten.de>
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, version 3.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

package net.sf.xcf.fts.nodes.filter;

import net.sf.xcf.fts.annotations.NodeName;
import net.sf.xcf.fts.nodes.transform.AbstractTransformNode;

/**
 * Filter that works on a boolean value computed by some transformation
 * node.
 *
 * @author iluetkeb
 */
@NodeName("BooleanFilter")
public class BooleanFilter extends AbstractTransformNode {
    private boolean active;

    @Override
    protected Object transform(Object input) throws Exception {
        if(input instanceof Boolean) {
            active = (Boolean)input;
            return null;
        } else if(active) {
                return input;
        } else {
                return null;
        }
    }

}
