/*
 * FilteredByNodeFilter.java
 *
 * Copyright (C) 2009 Bielefeld University
 * Copyright (C) 2009 Patrick Holthaus
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

package net.sf.xcf.fts.nodes.filter;

import net.sf.xcf.fts.Event;
import net.sf.xcf.fts.Node;
import net.sf.xcf.fts.NullEvent;

/**
 *
 * @author pholthau
 */
public class FilteredByNodeFilter extends AbstractFilter<NullEvent> {

    private final Node node;

    public FilteredByNodeFilter(Node node){
        this.node = node;
    }

    public boolean isMatch(Event<? extends NullEvent> e) throws Exception {
        return e.getData().source.equals(node);
    }
}
