/*
 * Copyright 2008, 2009 Bielefeld University
 * Copyright 2008, 2009 Ingo Luetkebohle <ingo@fargonauten.de>
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, version 3.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

package net.sf.xcf.fts.nodes.filter;

import java.util.Map;
import net.sf.xcf.fts.Event;
import net.sf.xcf.fts.annotations.NodeName;

/**
 *
 * @author iluetkeb
 */
@NodeName("MapCount")
public class MapCountFilter extends AbstractFilter<Map>{
    private final int minCount;
    
    public MapCountFilter(Integer minCount) {
        this.minCount = minCount;
    }

    public boolean isMatch(Event<? extends Map> e) throws Exception {
        return e.getData().size() >= minCount;
    }

}
