package net.sf.xcf.fts.nodes.filter;

import net.sf.xcf.fts.Event;

public class TagChangedFilter extends AbstractFilter<Object> {

	private Object previousValue;
	private String tagname;
	
	
	public TagChangedFilter(String tagname) {
		super();
		this.tagname = tagname;
	}

	@Override
	synchronized public boolean isMatch(Event<?> e) throws Exception {
		boolean result = !e.getTag(this.tagname).equals(this.previousValue);
		this.previousValue = e.getTag(this.tagname);
		if (result) {
			System.out.println("TagChangedFilter: Data " + e.getData() + " with tag " + tagname + "=" + this.previousValue + " allowed.");
		}
		return result;
	}

	
	
}
