/*
 * Copyright 2008, 2009 Bielefeld University
 * Copyright 2008, 2009 Ingo Luetkebohle <ingo@fargonauten.de>
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, version 3.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

package net.sf.xcf.fts.nodes.fusion;

import net.sf.xcf.fts.Event;
import net.sf.xcf.fts.Node;
import net.sf.xcf.fts.Pair;
import net.sf.xcf.fts.annotations.NodeName;

/**
 * Add the current time as the association timestamp.
 * 
 * @author iluetkeb
 */
@NodeName("AddTimestampAssociation")
public class TimestampAssociationTransform implements Node {

    @Override
    public Event handleEvent(Event input) throws Exception {
        return input.addTags(
                new Pair(TaggedFusionNode.MAP_FUSE_ASSOCIATION_ID,
                System.currentTimeMillis()));
    }

}
