/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package net.sf.xcf.fts.nodes.map;

import java.util.Map;
import net.sf.xcf.fts.Event;
import net.sf.xcf.fts.annotations.NodeName;
import net.sf.xcf.fts.nodes.filter.AbstractFilter;

/**
 * Compares the value of a given key to some known value using equals.
 * Does not pass if the key is not present.
 *
 * @author iluetkeb
 */
@NodeName("MatchKeyValue")
public class MatchKeyValue extends AbstractFilter<Map> {

    private final String key;
    private final Object value;

    public MatchKeyValue(String key, Object value) {
        if(key == null)
            throw new IllegalArgumentException("Key must not be null");
        if(value == null)
            throw new IllegalArgumentException("Value must not be null");
        this.key = key;
        this.value = value;
    }

    public boolean isMatch(Event<? extends Map> e) throws Exception {
        return e.getData().containsKey(key) && value.equals(e.getData().get(key));
    }

}
