/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package net.sf.xcf.fts.nodes.map;

import java.util.Map;
import net.sf.xcf.fts.annotations.NodeName;
import net.sf.xcf.fts.nodes.transform.AbstractTransformNode;

/**
 * Removes a predefined key from the input map.
 *
 * @author iluetkeb
 */
@NodeName("RemoveKey")
public class RemoveKey extends AbstractTransformNode<Map,Map> {

    private final String key;

    public RemoveKey(String key) {
        if(key == null)
            throw new IllegalArgumentException("Key must not be null");
        this.key = key;
    }

    @Override
    protected Map transform(Map input) throws Exception {
        input.remove(key);
        return input;
    }

}
