/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package net.sf.xcf.fts.nodes.map;

import java.util.Map;
import net.sf.xcf.fts.annotations.NodeName;
import net.sf.xcf.fts.nodes.transform.AbstractTransformNode;

/**
 * Statically inserts a predefined value for a predefined key.
 * 
 * @author iluetkeb
 */
@NodeName("StaticPutKey")
public class StaticPutKey extends AbstractTransformNode<Map,Map> {
    private final String key;
    private final Object value;

    public StaticPutKey(String key, Object value) {
        if(key == null)
            throw new IllegalArgumentException("Key must not be null");
        if(value == null)
            throw new IllegalArgumentException("Value must not be null");
        this.key = key;
        this.value = value;
    }

    @Override
    protected Map transform(Map input) throws Exception {
        input.put(key, value);
        return input;
    }

}
