/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package net.sf.xcf.fts.nodes.pair;

import net.sf.xcf.fts.Event;
import net.sf.xcf.fts.Pair;
import net.sf.xcf.fts.annotations.NodeName;
import net.sf.xcf.fts.nodes.filter.AbstractFilter;

/**
 * Takes a pair and passes through  if the first value is equal
 * to the configured value.
 *
 * @author ingo
 */
@NodeName("MatchFirst")
public class MatchFirstFilter<T> extends AbstractFilter<Pair<String,? extends T>>{

    private final String expectedValue;

    public MatchFirstFilter(String expectedValue) {
        this.expectedValue = expectedValue;
    }
    
    @Override
    public boolean isMatch(Event<? extends Pair<String, ? extends T>> e) {
        return expectedValue.equals(e.getData().first);
    }
}
