/*
 * Copyright 2008, 2009 Bielefeld University
 * Copyright 2008, 2009 Ingo Luetkebohle <ingo@fargonauten.de>
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, version 3.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

package net.sf.xcf.fts.nodes.sink;

/**
 *
 * @author iluetkeb
 */
public class BufferOutputEvent {
    public final byte[] buf;
    public final int offset, length;

    public BufferOutputEvent(byte[] buf) {
        this(buf, 0, buf.length);
    }
    public BufferOutputEvent(byte[] buf, int offset, int length) {
        this.buf = buf;
        this.offset = offset;
        this.length = length;
    }

    @Override
    public String toString() {
        StringBuffer sb = new StringBuffer();
        sb.append("buf=[");
        for(int i = 0; i < (length-1); ++i) {
            sb.append(Integer.toString(buf[i + offset] & 0xFF)).append(", ");

        }
        sb.append(Integer.toString(buf[offset + length - 1] & 0xFF));
        sb.append("]");
        return sb.toString();
    }
}
