/*
 * Copyright 2008, 2009 Bielefeld University
 * Copyright 2008, 2009 Ingo Luetkebohle <ingo@fargonauten.de>
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, version 3.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

package net.sf.xcf.fts.nodes.sink;

import java.io.OutputStream;

/**
 *
 * @author iluetkeb
 */
public class OutputStreamSink extends SinkAdapter<BufferOutputEvent> {
    private final OutputStream os;
    
    public OutputStreamSink(OutputStream os) {
        super("OutputStreamSink");
        this.os = os;
    }

    @Override
    protected void pushItem(BufferOutputEvent evt) throws Exception {
        os.write(evt.buf, evt.offset, evt.length);
        os.flush();
    }

}
