/*
 * Copyright 2008, 2009 Bielefeld University
 * Copyright 2008, 2009 Ingo Luetkebohle, Sebastian Wrede, Jan Schaefer
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, version 3.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package net.sf.xcf.fts.nodes.sink;

import net.sf.xcf.fts.Sink;
import net.sf.xcf.fts.Event;
import net.sf.xcf.fts.nodes.AbstractNode;

public abstract class SinkAdapter<TIn> extends AbstractNode<TIn, Void>
        implements Sink<TIn> {

    public SinkAdapter(){
        super();
    }

    public SinkAdapter(String name) {
        super(name);
    }

    @Override
    public Event<Void> handleEvent(Event<? extends TIn> input) throws Exception {
        push(input);
        return null;
    }

    @Override
    public void push(Event<? extends TIn> e) throws Exception {
        pushItem(e.getData());
    }

    protected abstract void pushItem(TIn e) throws Exception;
}
