/*
 * Copyright 2008, 2009 Bielefeld University
 * Copyright 2008, 2009 Ingo Luetkebohle, Sebastian Wrede, Jan Schaefer
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, version 3.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

package net.sf.xcf.fts.nodes.source;

import java.util.Collection;

import java.util.Iterator;
import net.sf.xcf.fts.annotations.NodeName;

/**
 * Simple source that returns an iterator over the collection it was given
 * during construction
 * 
 * @author ingo
 */
@NodeName("CollectionSource")
public class CollectionIteratorSource<T> extends SourceAdapter<Iterator<T>> {
    private final Collection<T> data;

    public CollectionIteratorSource(Collection<T> data) {
        super("CollectionIteratorSource");
        this.data = data;
    }

    @Override
    public Iterator<T> nextItem() throws Exception {
        return this.data.iterator();
    }

    public Collection<T> getCollection() {
        return this.data;
    }
}
