/*
 * Copyright 2008, 2009 Bielefeld University
 * Copyright 2008, 2009 Ingo Luetkebohle <ingo@fargonauten.de>
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, version 3.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

package net.sf.xcf.fts.nodes.source;

import net.sf.xcf.fts.annotations.NodeName;

/**
 *
 * @author iluetkeb
 */
@NodeName("OnceSource")
public class OnceSource<T> extends SourceAdapter<T> {
    private boolean first = true;
    private final T obj;

    public OnceSource(T obj) {
        this.obj = obj;
    }

    @Override
    protected T nextItem() throws Exception {
        if(first) {
            first = false;
            return obj;
        } else {
            // wait forever. ties up a thread, but, well...
            Thread.sleep(Long.MAX_VALUE);
            return null;
        }
    }

}
