/*
 * Copyright 2008, 2009 Bielefeld University
 * Copyright 2008, 2009 Ingo Luetkebohle, Sebastian Wrede, Jan Schaefer
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, version 3.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

package net.sf.xcf.fts.nodes.source;


import java.util.concurrent.BlockingQueue;
import net.sf.xcf.fts.annotations.NodeName;

/**
 * Source that takes the head from a queue.
 *
 * @author ingo
 */
@NodeName("QueueHeadSource")
public class QueueHeadSource<T> extends SourceAdapter<T> {
    private final BlockingQueue<T> queue;
    
    public QueueHeadSource(BlockingQueue<T> queue) {
        super("QueueHeadSource");
        this.queue = queue;
    }

    @Override
    public T nextItem() throws Exception {
        return this.queue.take();
    }
}
