/*
 * Copyright 2008, 2009 Bielefeld University
 * Copyright 2008, 2009 Ingo Luetkebohle, Sebastian Wrede, Jan Schaefer
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, version 3.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package net.sf.xcf.fts.nodes.source;

import net.sf.xcf.fts.annotations.NodeName;

/**
 * Simple source that returns the object it was given in the
 * ctor.
 *
 * @author ingo
 */
@NodeName("StaticSource")
public class StaticSource<T> extends SourceAdapter<T> {

    private final T data;

    public StaticSource(T data) {
        super("StaticSource");
        this.data = data;
    }

    @Override
    public T nextItem() throws Exception {
        return data;
    }

    @Override
    public String toString() {
        return "StaticSource[" + data + "]";
    }
}
