/*
 * Copyright 2008, 2009 Bielefeld University
 * Copyright 2008, 2009 Ingo Luetkebohle, Sebastian Wrede, Jan Schaefer
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, version 3.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package net.sf.xcf.fts.nodes.source;

import net.sf.xcf.fts.annotations.NodeName;
import nu.xom.Document;
import nu.xom.Element;
import nu.xom.Text;

/**
 *
 * @author jschaefe
 */
@NodeName("XMLTimestampSource")
public class XOMTimeSource extends SourceAdapter<Document> {

    private final Text timestamp;
    private final Document doc;

    public XOMTimeSource() {
        super("XOM timestamp");
        timestamp = new Text("");
        Element ts = new Element("timestamp");
        ts.appendChild(timestamp);
        doc = new Document(ts);
    }

    public Document nextItem() throws Exception {
        timestamp.setValue("" + System.currentTimeMillis());
        return (Document) doc.copy();
    }
}
