/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package net.sf.xcf.fts.nodes.time;

import net.sf.xcf.fts.Event;
import net.sf.xcf.fts.annotations.NodeName;

/**
 * A variant of the triggered delay filter that switches between two
 * pre-defined timeouts.
 * 
 * @author iluetkeb
 */
@NodeName("SwitchingTriggeredDelay")
public class SwitchingTriggeredDelayFilter extends TriggeredDelayFilter {

    private final long[] timeouts;
    private int index = 0;

    public SwitchingTriggeredDelayFilter(Long timeout1, Long timeout2) {
        timeouts = new long[]{timeout1, timeout2};
    }

    @Override
    protected boolean expired(Event e, long timestamp) {
        final long currentTimeout = timeouts[index];
        index = (index + 1) % timeouts.length;
        return (System.currentTimeMillis() - timestamp) >= currentTimeout;
    }
}
