/*
 * Copyright 2008, 2009 Bielefeld University
 * Copyright 2008, 2009 Ingo Luetkebohle, Sebastian Wrede, Jan Schaefer
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, version 3.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

package net.sf.xcf.fts.nodes.transform;

import net.sf.xcf.fts.Event;
import net.sf.xcf.fts.annotations.Transform;
import net.sf.xcf.fts.nodes.AbstractNode;

/**
 *
 * @author iluetkeb
 */
@Transform
public abstract class AbstractTransformNode<TIn, TOut> extends AbstractNode<TIn, TOut> {

    public AbstractTransformNode(){
        super();
    }

    public AbstractTransformNode(String name) {
        super(name);
    }

    protected abstract TOut transform(TIn input) throws Exception;

    public final Event<? extends TOut> handleEvent(Event<? extends TIn> input) throws Exception {
        return input.createDerived(transform(input.getData()));
    }

}
