/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package net.sf.xcf.fts.nodes.transform;

import net.sf.xcf.fts.annotations.NodeName;

/**
 * Compares for equality, produces boolean.
 * 
 * @author iluetkeb
 */
@NodeName("Equals")
public class EqualsTransform<T> extends AbstractTransformNode<T, Boolean> {

    private final T value;

    public EqualsTransform(T targetValue) {
        if(targetValue == null)
            throw new IllegalArgumentException("Target value must not be null");
        this.value = targetValue;
    }

    @Override
    protected Boolean transform(T input) throws Exception {
        return value.equals(input);
    }

}
