/*
 * Copyright 2008, 2009 Bielefeld University
 * Copyright 2008, 2009 Ingo Luetkebohle <ingo@fargonauten.de>
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, version 3.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

package net.sf.xcf.fts.nodes.transform;

import net.sf.xcf.fts.annotations.NodeName;

/**
 *
 * @author iluetkeb
 */
@NodeName("ApplySingleToArray")
public class GenericInplaceArrayProcessor<T> extends AbstractTransformNode<T[],T[]> {
    private final AbstractTransformNode<? super T, ? extends T> backend;
    
    public GenericInplaceArrayProcessor(AbstractTransformNode<? super T, ? extends T> backend) {
        this.backend = backend;
    }

    @Override
    protected T[] transform(T[] input) throws Exception {
        for(int i = 0; i < input.length; ++i)
            input[i] = backend.transform(input[i]);

        return input;
    }

}
