/*
 * Copyright 2008, 2009 Bielefeld University
 * Copyright 2008, 2009 Ingo Luetkebohle <ingo@fargonauten.de>
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, version 3.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

package net.sf.xcf.fts.nodes.transform;

import java.util.UUID;
import net.sf.xcf.fts.Event;
import net.sf.xcf.fts.Pair;
import net.sf.xcf.fts.annotations.NodeName;
import net.sf.xcf.fts.annotations.Transform;
import net.sf.xcf.fts.Node;

/**
 * Creates that assigns a random value to a specified tag name.
 *
 * @author iluetkeb
 */
@NodeName("RandomTag")
@Transform
public class RandomTaggingNode implements Node {
    private final String tagName;

    /** Create tagging node using the given tag name. */
    public RandomTaggingNode(String tagName) {
        this.tagName = tagName;
    }

    public Event handleEvent(Event input) throws Exception {
        return input.addTags(new Pair(tagName, UUID.randomUUID()));
    }

}
