/*
 * Copyright 2008, 2009 Bielefeld University
 * Copyright 2008, 2009 Ingo Luetkebohle <ingo@fargonauten.de>
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, version 3.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

package net.sf.xcf.fts.nodes.transform;

import net.sf.xcf.fts.annotations.NodeName;

/**
 * Transform that ignores its input and outputs always the same object.
 * Sort of like StaticSource, but in-stream.
 *
 * @author iluetkeb
 */
@NodeName("StaticObject")
public class StaticTransform<T> extends AbstractTransformNode<Object,T> {
    private final T object;
    
    public StaticTransform(T object) {
        this.object = object;
    }

    @Override
    protected T transform(Object input) throws Exception {
        return object;
    }

}
