/*
 * Copyright 2008, 2009 Bielefeld University
 * Copyright 2008, 2009 Ingo Luetkebohle, Sebastian Wrede, Jan Schaefer
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, version 3.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

package net.sf.xcf.fts.nodes.transform.io;

import java.io.File;
import net.sf.xcf.fts.annotations.NodeName;
import net.sf.xcf.fts.annotations.Transform;
import net.sf.xcf.fts.nodes.transform.AbstractTransformNode;

/**
 * A transformer that opens its argument as a file.
 *
 * @author ingo
 */
@NodeName("Filename2File")
@Transform
public class Filename2File extends AbstractTransformNode<String, File> {

    public Filename2File() {
        super("Filename2File");
    }

    @Override
    protected File transform(String input) throws Exception {
        return new File(input);
    }

}
