/*
 * Copyright 2008, 2009 Bielefeld University
 * Copyright 2008, 2009 Ingo Luetkebohle <ingo@fargonauten.de>
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, version 3.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

package net.sf.xcf.fts.nodes.transform.list;

import net.sf.xcf.fts.nodes.transform.*;
import java.util.ArrayList;
import java.util.List;
import net.sf.xcf.fts.annotations.NodeName;

/**
 * Performs the input list operation and returns the resulting list.
 *
 * @author iluetkeb
 */
@NodeName("ListCollector")
public class ListCollectorNode extends AbstractTransformNode<ListEvent,List>{
    private final List list = new ArrayList();

    @Override
    protected List transform(ListEvent input) throws Exception {
        switch(input.op) {
            case Add:
                list.add(input.argument);
                break;
            case Insert:
                list.add(input.position, input.argument);
                break;
            case Clear:
                list.clear();
                break;
        }
        
        return list;
    }

}
