/*
 * Copyright 2008, 2009 Bielefeld University
 * Copyright 2008, 2009 Ingo Luetkebohle <ingo@fargonauten.de>
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, version 3.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package net.sf.xcf.fts.nodes.transform.list;

/**
 *
 * @author iluetkeb
 */
public class ListEvent {

    public enum ListOperation {
        Add,
        Insert,
        Clear
    }

    public final ListOperation op;
    public final Object argument;
    public final int position;

    public ListEvent(ListOperation op, Object argument, int position) {
        this.op = op;
        this.argument = argument;
        this.position = position;
    }

    @Override
    public String toString() {
        return "ListEvent[op=" + op + ", arg=" + argument +
                ", pos=" + position + "]";
    }
}
