package net.sf.xcf.fts.serial.transducer;

/////*
// * To change this template, choose Tools | Templates
// * and open the template in the editor.
// */
//
//package de.unibi.agai.ip.transducer;
//
//import de.unibi.agai.ip.pmatch.ConditionalDispatcher;
//import de.unibi.agai.ip.pmatch.NoMatchException;
//import java.util.EnumMap;
//import java.util.concurrent.ExecutionException;
//
///**
// * Implements a transducer based on Enums as state and input sets.
// *
// * To reduce the number of states necessary, numerical inputs may be provided
// * as additional argument data.
// *
// * @param K the set of states
// * @param I the input set
// * @param T optional paremeters for the input
// *
// * @author iluetkeb
// */
//public class EnumDispatchTransducer<K extends Enum<K>, I extends Enum<I>, T, O>
//        implements ConditionalDispatcher<Pair<I, T>, O, Pair<K, I>, OutputFunction<I, T, O>> {
//
//    private EnumMap<K, EnumMap<I, K>> nextStates;
//    private EnumMap<K, EnumMap<I, OutputFunction<I, T, O>>> outputs;
//    private K state;
//    private final Class<I> iClass;
//    private final K errorState;
//
//    /** Create a new enum transducer.
//     * @param errorState the state to enter when an output function fails.
//     *   may be null, in which case the current state will be kept.
//     */
//    public EnumDispatchTransducer(Class<K> kClass, Class<I> iClass, K errorState) {
//        nextStates = new EnumMap(kClass);
//        outputs = new EnumMap(kClass);
//        this.iClass = iClass;
//        this.errorState = errorState;
//    }
//
//    /**
//     * Add a callable that is fired when input pattern.i occurs in state
//     * pattern.k.
//     */
//    @Override
//    public void add(Pair<K, I> pattern, OutputFunction<I, T, O> callable) {
//        if(!outputs.containsKey(pattern.k)) {
//            outputs.put(pattern.k, new EnumMap<I, OutputFunction<I, T, O>>(iClass));
//        }
//        outputs.get(pattern.k).put(pattern.i, callable);
//    }
//
//    /**
//     * Perform state change appropriate for input in current state and
//     * return the output on following that transition. If an exception
//     * occurs, the
//     *
//     * @throws NoMatchException when no output func or no outgoing arc for
//     *   given data is present
//     * @throws ExecutionException when the output function throws
//     */
//    @Override
//    public O dispatch(Pair<I, T> data) throws NoMatchException, ExecutionException {
//        OutputFunction<I, T, O> fn = getOutFunc(data.k);
//        K newState = getNextState(data.k);
//        try {
//            final O result = fn.produce(data);
//            state = newState;
//            return result;
//        } catch(Exception ex) {
//            if(errorState != null)
//                state = errorState;
//            throw new ExecutionException(ex);
//        }
//    }
//
//    /**
//     * Get output function for current state and input data. Throws if none
//     * exists.
//     */
//    protected OutputFunction<I, T, O> getOutFunc(I data) throws NoMatchException {
//        OutputFunction<I, T, O> fn = outputs.get(state).get(data);
//        if(fn == null)
//            throw new NoMatchException("No matching output function " +
//                    " in state " + state, data);
//        return fn;
//    }
//    /** Gets the next state for input data. Throws if no out arc exists. */
//    protected K getNextState(I data) throws NoMatchException {
//        K newState = nextStates.get(state).get(data);
//        if(newState == null)
//            throw new NoMatchException("Input not permitted" +
//                    " in state " + state, data);
//        return newState;
//    }
//
//}
